## Bulk edit token validation rules `client.tokenValidation.rules.bulkEdit(RuleBulkEditParamsparams, RequestOptionsoptions?): SinglePage` **patch** `/zones/{zone_id}/token_validation/rules/bulk` Edit token validation rules. A request can update multiple Token Validation Rules. Rules can be re-ordered using the `position` field. Returns all updated rules. ### Parameters - `params: RuleBulkEditParams` - `zone_id: string` Path param: Identifier. - `body: Array` Body param - `id: string` Rule ID this patch applies to - `action?: "log" | "block"` Action to take on requests that match operations included in `selector` and fail `expression`. - `"log"` - `"block"` - `description?: string` A human-readable description that gives more details than `title`. - `enabled?: boolean` Toggle rule on or off. - `expression?: string` Rule expression. Requests that fail to match this expression will be subject to `action`. For details on expressions, see the [Cloudflare Docs](https://developers.cloudflare.com/api-shield/security/jwt-validation/). - `position?: APIShieldIndex | APIShieldBefore | APIShieldAfter` Update rule order among zone rules. - `APIShieldIndex` - `index: number` Move rule to this position - `APIShieldBefore` Move rule to after rule with ID. - `before?: string` Move rule to before rule with this ID. - `APIShieldAfter` Move rule to before rule with ID. - `after?: string` Move rule to after rule with this ID. - `selector?: Selector` Select operations covered by this rule. For details on selectors, see the [Cloudflare Docs](https://developers.cloudflare.com/api-shield/security/jwt-validation/). - `exclude?: Array | null` Ignore operations that were otherwise included by `include`. - `operation_ids?: Array` Excluded operation IDs. - `include?: Array | null` Select all matching operations. - `host?: Array` Included hostnames. - `title?: string` A human-readable name for the rule. ### Returns - `TokenValidationRule` A Token Validation rule that can enforce security policies using JWT Tokens. - `action: "log" | "block"` Action to take on requests that match operations included in `selector` and fail `expression`. - `"log"` - `"block"` - `description: string` A human-readable description that gives more details than `title`. - `enabled: boolean` Toggle rule on or off. - `expression: string` Rule expression. Requests that fail to match this expression will be subject to `action`. For details on expressions, see the [Cloudflare Docs](https://developers.cloudflare.com/api-shield/security/jwt-validation/). - `selector: Selector` Select operations covered by this rule. For details on selectors, see the [Cloudflare Docs](https://developers.cloudflare.com/api-shield/security/jwt-validation/). - `exclude?: Array | null` Ignore operations that were otherwise included by `include`. - `operation_ids?: Array` Excluded operation IDs. - `include?: Array | null` Select all matching operations. - `host?: Array` Included hostnames. - `title: string` A human-readable name for the rule. - `id?: string` UUID. - `created_at?: string` - `last_updated?: string` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const tokenValidationRule of client.tokenValidation.rules.bulkEdit({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', body: [{ id: '0d9bf70c-92e1-4bb3-9411-34a3bcc59003' }], })) { console.log(tokenValidationRule.id); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": [ { "action": "log", "description": "Long description for Token Validation Rule", "enabled": true, "expression": "is_jwt_valid(\"52973293-cb04-4a97-8f55-e7d2ad1107dd\") or is_jwt_valid(\"46eab8d1-6376-45e3-968f-2c649d77d423\")", "selector": { "exclude": [ { "operation_ids": [ "f9c5615e-fe15-48ce-bec6-cfc1946f1bec", "56828eae-035a-4396-ba07-51c66d680a04" ] } ], "include": [ { "host": [ "v1.example.com", "v2.example.com" ] } ] }, "title": "Example Token Validation Rule", "id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415", "created_at": "2014-01-01T05:20:00.12345Z", "last_updated": "2014-01-01T05:20:00.12345Z" } ], "success": true, "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ```